Welcome to Subscribe On Youtube

Question

Formatted question description: https://leetcode.ca/all/26.html

Given an integer array nums sorted in non-decreasing order, remove the duplicates in-place such that each unique element appears only once. The relative order of the elements should be kept the same. Then return the number of unique elements in nums.

Consider the number of unique elements of nums to be k, to get accepted, you need to do the following things:

  • Change the array nums such that the first k elements of nums contain the unique elements in the order they were present in nums initially. The remaining elements of nums are not important as well as the size of nums.
  • Return k.

Custom Judge:

The judge will test your solution with the following code:

int[] nums = [...]; // Input array
int[] expectedNums = [...]; // The expected answer with correct length

int k = removeDuplicates(nums); // Calls your implementation

assert k == expectedNums.length;
for (int i = 0; i < k; i++) {
    assert nums[i] == expectedNums[i];
}

If all assertions pass, then your solution will be accepted.

 

Example 1:

Input: nums = [1,1,2]
Output: 2, nums = [1,2,_]
Explanation: Your function should return k = 2, with the first two elements of nums being 1 and 2 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2:

Input: nums = [0,0,1,1,1,2,2,3,3,4]
Output: 5, nums = [0,1,2,3,4,_,_,_,_,_]
Explanation: Your function should return k = 5, with the first five elements of nums being 0, 1, 2, 3, and 4 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

 

Constraints:

  • 1 <= nums.length <= 3 * 104
  • -100 <= nums[i] <= 100
  • nums is sorted in non-decreasing order.

Algorithm

Use fast and slow pointers to record the traversed coordinates. At the beginning, both pointers point to the first number. If the two pointers point to the same number, the fast pointer will move forward. If they are different, both pointers will move forward. One step, so that when the fast pointer goes through the entire array, the current coordinate of the slow pointer plus 1 is the number of different numbers in the array.

Code

  • 
    // same thing, two pointers
    public class Remove_Duplicates_from_Sorted_Array {
    
    	public class Solution {
    	    public int removeDuplicates(int[] nums) {
    	        if(nums == null || nums.length == 0) {
    	            return 0;
    	        }
    
    	        int i = 0; // slow pointer
    	        int j = 0; // fast pointer
    
    	        while(j < nums.length) {
    	            while(j + 1< nums.length && nums[j] == nums[j + 1]) {
    	                j++;
    	            }
    
    	            nums[i] = nums[j];
    
    	            i++;
    	            j++;
    	        }
    
    	        return i; // i is incremented, but is index. So same as length
    	    }
    	}
    
    }
    
    ############
    
    class Solution {
        public int removeDuplicates(int[] nums) {
            int i = 0;
            for (int num : nums) {
                if (i < 1 || num != nums[i - 1]) {
                    nums[i++] = num;
                }
            }
            return i;
        }
    }
    
  • // OJ: https://leetcode.com/problems/remove-duplicates-from-sorted-array/
    // Time: O(N)
    // Space: O(1)
    class Solution {
    public:
        int removeDuplicates(vector<int>& A) {
            int j = 0;
            for (int n : A) {
                if (j - 1 < 0 || A[j - 1] != n) A[j++] = n;
            }
            return j;
        }
    };
    
  • class Solution:
        def removeDuplicates(self, nums: List[int]) -> int:
            i = 0
            for num in nums:
                if i < 1 or num != nums[i - 1]:
                    nums[i] = num
                    i += 1
            return i
    
    ############
    
    class Solution(object):
      def removeDuplicates(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        if len(nums) <= 1:
          return len(nums)
        slow = 0
        for i in range(1, len(nums)):
          if nums[i] != nums[slow]:
            slow += 1
            nums[slow] = nums[i]
        return slow + 1
    
    
  • func removeDuplicates(nums []int) int {
        i := 0
    	for _, num := range nums {
    		if i < 1 || num != nums[i-1] {
    			nums[i] = num
    			i++
    		}
    	}
    	return i
    }
    
  • /**
     * @param {number[]} nums
     * @return {number}
     */
    var removeDuplicates = function (nums) {
        let i = 0;
        for (const num of nums) {
            if (i < 1 || num != nums[i - 1]) {
                nums[i++] = num;
            }
        }
        return i;
    };
    
    
  • public class Solution {
        public int RemoveDuplicates(int[] nums) {
            int i = 0;
            foreach(int num in nums)
            {
                if (i < 1 || num != nums[i - 1])
                {
                    nums[i++] = num;
                }
            }
            return i;
        }
    }
    
  • impl Solution {
        pub fn remove_duplicates(nums: &mut Vec<i32>) -> i32 {
            let mut len = 0;
            for i in 0..nums.len() {
                if i == 0 || nums[i] != nums[len - 1] {
                    nums[len] = nums[i];
                    len += 1;
                }
            }
            len as i32
        }
    }
    
    
  • class Solution {
    
        /**
         * @param Integer[] $nums
         * @return Integer
         */
        function removeDuplicates(&$nums) {
            $k = 0;
            foreach($nums as $x) {
                if ($k == 0 || $x != $nums[$k - 1]) {
                    $nums[$k++] = $x;
                }
            }
            return $k;
        }
    }
    
  • function removeDuplicates(nums: number[]): number {
        let k: number = 0;
        for (const x of nums) {
            if (k === 0 || x !== nums[k - 1]) {
                nums[k++] = x;
            }
        }
        return k;
    }
    
    

All Problems

All Solutions